/*************************************************************************/
/* Programm SETCOM-B. Zum Setzen der Schnittstellenparameter aus einem	 */
/* Batchfile heraus. Aus Grnden der Kompaktheit/bersichtlichkeit kaum  */
/* Fehlerberprfung, Parameter daher mit SETCOM-I vorher testen.	 */
/* Aufruf: SETCOM-B <COM-Port> <Baudrate> <Datenbits> <Stopbits> <Parity>*/
/*************************************************************************/

#include <dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>

#include "baudtab.h"		 /* Einbinden der Baudraten-Tabelle */
#include "getcom.c"
#include "setcom.c"

main(argc,argv)
 int argc;
 char *argv[];
{
 int com, dbit, sbit, ret;
 long baud;
 char *par;

 if ( argc != 6 )    /* Bei falscher Anzahl Argumente -> Fehlermeldung */
  {
   printf("usage : SETCOM-B COM-Port Baudrate Databits Stopbits Parity\n");
   printf("z.B.  : SETCOM-B com2 19200 8 1 o");
   exit(6);			/* Programm beenden mit ErrorLevel = 6 */
  }

/* Auswerten der Kommandozeile. Hier erfolgt keinerlei Prfung auf     */
/* Eingabefehler. Ein Teil der mglichen Fehler wird in der Funktion   */
/* Setcom abgefangen, wobei ein Returnwert zurckgegeben wird.	       */

 com  = argv[1][3] - '0';		   /* Schnittstellen-Nummer    */
 baud = atol(argv[2]);			   /* Baudrate		       */
 dbit = atoi(argv[3]);			   /* Anzahl Datenbits	       */
 sbit = atoi(argv[4]);			   /* Anzahl Stopbits	       */
 par  = strupr(argv[5]);		   /* Paritt		       */

/* Aufruf der Funktion SETCOM. Der Return-Wert gibt Auskunft, ob die   */
/* Umkonfiguration der Schnittstelle geklappt hat.		       */

 ret  = setcom(com,baud,dbit,sbit,par);

/* Bei Fehler Ausgabe einer Fehlermeldung und Programmende mit dem im  */
/* der Funktion Setcom gesetzten ErrorLevel.			       */

 if (ret)
  {
   fprintf(stderr,"Fehler in der Kommandozeile\n");
   exit(ret);
  }

/* Bei fehlerfreier Ausfhrung Ausgabe der eingestellten Parameter.    */

 getcom(com);

 return(0);				    /* Errorlevel auf 0 setzen */
}
